/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.supplier.service.impl;

import me.zhengjie.modules.supplier.domain.Supplier;
import me.zhengjie.utils.ValidationUtil;
import me.zhengjie.utils.FileUtil;
import lombok.RequiredArgsConstructor;
import me.zhengjie.modules.supplier.repository.SupplierRepository;
import me.zhengjie.modules.supplier.service.SupplierService;
import me.zhengjie.modules.supplier.service.dto.SupplierDto;
import me.zhengjie.modules.supplier.service.dto.SupplierQueryCriteria;
import me.zhengjie.modules.supplier.service.mapstruct.SupplierMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import me.zhengjie.utils.PageUtil;
import me.zhengjie.utils.QueryHelp;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import me.zhengjie.utils.PageResult;

/**
* @website https://eladmin.vip
* @description 服务实现
* @author Bu
* @date 2023-09-14
**/
@Service
@RequiredArgsConstructor
public class SupplierServiceImpl implements SupplierService {

    private final SupplierRepository supplierRepository;
    private final SupplierMapper supplierMapper;

    @Override
    public PageResult<SupplierDto> queryAll(SupplierQueryCriteria criteria, Pageable pageable){
        Page<Supplier> page = supplierRepository.findAll((root, criteriaQuery, criteriaBuilder) -> QueryHelp.getPredicate(root,criteria,criteriaBuilder),pageable);
        return PageUtil.toPage(page.map(supplierMapper::toDto));
    }

    @Override
    public List<SupplierDto> queryAll(SupplierQueryCriteria criteria){
        return supplierMapper.toDto(supplierRepository.findAll((root, criteriaQuery, criteriaBuilder) -> QueryHelp.getPredicate(root,criteria,criteriaBuilder)));
    }

    @Override
    @Transactional
    public SupplierDto findById(Integer supplierId) {
        Supplier supplier = supplierRepository.findById(supplierId).orElseGet(Supplier::new);
        ValidationUtil.isNull(supplier.getSupplierId(),"Supplier","supplierId",supplierId);
        return supplierMapper.toDto(supplier);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void create(Supplier resources) {
        supplierRepository.save(resources);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(Supplier resources) {
        Supplier supplier = supplierRepository.findById(resources.getSupplierId()).orElseGet(Supplier::new);
        ValidationUtil.isNull( supplier.getSupplierId(),"Supplier","id",resources.getSupplierId());
        supplier.copy(resources);
        supplierRepository.save(supplier);
    }

    @Override
    public void deleteAll(Integer[] ids) {
        for (Integer supplierId : ids) {
            supplierRepository.deleteById(supplierId);
        }
    }

    @Override
    public void download(List<SupplierDto> all, HttpServletResponse response) throws IOException {
        List<Map<String, Object>> list = new ArrayList<>();
        for (SupplierDto supplier : all) {
            Map<String,Object> map = new LinkedHashMap<>();
            map.put("供应商编码", supplier.getCode());
            map.put("供应商名称", supplier.getName());
            map.put("创建人", supplier.getCreateBy());
            map.put("创建日期", supplier.getCreateTime());
            map.put("更新人", supplier.getUpdateBy());
            map.put("更新时间", supplier.getUpdateTime());
            list.add(map);
        }
        FileUtil.downloadExcel(list, response);
    }
}